#ifndef _H_1124BA725934C139423036FE8CAF1E20_Complex32_DCPS_H_
#define _H_1124BA725934C139423036FE8CAF1E20_Complex32_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Complex32_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Complex32_TypeSupportInterface;

            typedef Complex32_TypeSupportInterface * Complex32_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Complex32_TypeSupportInterface> Complex32_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Complex32_TypeSupportInterface> Complex32_TypeSupportInterface_out;


            class Complex32_DataWriter;

            typedef Complex32_DataWriter * Complex32_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Complex32_DataWriter> Complex32_DataWriter_var;
            typedef DDS_DCPSInterface_out < Complex32_DataWriter> Complex32_DataWriter_out;


            class Complex32_DataReader;

            typedef Complex32_DataReader * Complex32_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Complex32_DataReader> Complex32_DataReader_var;
            typedef DDS_DCPSInterface_out < Complex32_DataReader> Complex32_DataReader_out;


            class Complex32_DataReaderView;

            typedef Complex32_DataReaderView * Complex32_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Complex32_DataReaderView> Complex32_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Complex32_DataReaderView> Complex32_DataReaderView_out;

            struct Complex32_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Complex32_, struct Complex32_Seq_uniq_> Complex32_Seq;
            typedef DDS_DCPSSequence_var < Complex32_Seq> Complex32_Seq_var;
            typedef DDS_DCPSSequence_out < Complex32_Seq> Complex32_Seq_out;

            class  Complex32_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Complex32_TypeSupportInterface_ptr _ptr_type;
                typedef Complex32_TypeSupportInterface_var _var_type;

                static Complex32_TypeSupportInterface_ptr _duplicate (Complex32_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Complex32_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Complex32_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Complex32_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Complex32_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Complex32_TypeSupportInterface () {};
                ~Complex32_TypeSupportInterface () {};
            private:
                Complex32_TypeSupportInterface (const Complex32_TypeSupportInterface &);
                Complex32_TypeSupportInterface & operator = (const Complex32_TypeSupportInterface &);
            };

            class  Complex32_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Complex32_DataWriter_ptr _ptr_type;
                typedef Complex32_DataWriter_var _var_type;

                static Complex32_DataWriter_ptr _duplicate (Complex32_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Complex32_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Complex32_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Complex32_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Complex32_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Complex32_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Complex32_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Complex32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Complex32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Complex32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Complex32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Complex32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Complex32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Complex32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Complex32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Complex32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Complex32_& instance_data) = 0;

            protected:
                Complex32_DataWriter () {};
                ~Complex32_DataWriter () {};
            private:
                Complex32_DataWriter (const Complex32_DataWriter &);
                Complex32_DataWriter & operator = (const Complex32_DataWriter &);
            };

            class  Complex32_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Complex32_DataReader_ptr _ptr_type;
                typedef Complex32_DataReader_var _var_type;

                static Complex32_DataReader_ptr _duplicate (Complex32_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Complex32_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Complex32_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Complex32_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Complex32_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Complex32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Complex32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Complex32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Complex32_& instance) = 0;

            protected:
                Complex32_DataReader () {};
                ~Complex32_DataReader () {};
            private:
                Complex32_DataReader (const Complex32_DataReader &);
                Complex32_DataReader & operator = (const Complex32_DataReader &);
            };

            class  Complex32_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Complex32_DataReaderView_ptr _ptr_type;
                typedef Complex32_DataReaderView_var _var_type;

                static Complex32_DataReaderView_ptr _duplicate (Complex32_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Complex32_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Complex32_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Complex32_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Complex32_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Complex32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Complex32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Complex32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Complex32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Complex32_& instance) = 0;

            protected:
                Complex32_DataReaderView () {};
                ~Complex32_DataReaderView () {};
            private:
                Complex32_DataReaderView (const Complex32_DataReaderView &);
                Complex32_DataReaderView & operator = (const Complex32_DataReaderView &);
            };
        }

    }

}

#endif
